require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

RSpec.describe MovieTagsController, type: :controller do

  # This should return the minimal set of attributes required to create a valid
  # MovieTag. As you add validations to MovieTag, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) {
    skip("Add a hash of attributes valid for your model")
  }

  let(:invalid_attributes) {
    skip("Add a hash of attributes invalid for your model")
  }

  # This should return the minimal set of values that should be in the session
  # in order to pass any filters (e.g. authentication) defined in
  # MovieTagsController. Be sure to keep this updated too.
  let(:valid_session) { {} }

  before { skip("TODO") }

  describe "GET #index" do
    it "assigns all movie_tags as @movie_tags" do
      movie_tag = MovieTag.create! valid_attributes
      get :index, params: {}, session: valid_session
      expect(assigns(:movie_tags)).to eq([movie_tag])
    end
  end

  describe "GET #show" do
    it "assigns the requested movie_tag as @movie_tag" do
      movie_tag = MovieTag.create! valid_attributes
      get :show, params: {id: movie_tag.to_param}, session: valid_session
      expect(assigns(:movie_tag)).to eq(movie_tag)
    end
  end

  describe "GET #new" do
    it "assigns a new movie_tag as @movie_tag" do
      get :new, params: {}, session: valid_session
      expect(assigns(:movie_tag)).to be_a_new(MovieTag)
    end
  end

  describe "GET #edit" do
    it "assigns the requested movie_tag as @movie_tag" do
      movie_tag = MovieTag.create! valid_attributes
      get :edit, params: {id: movie_tag.to_param}, session: valid_session
      expect(assigns(:movie_tag)).to eq(movie_tag)
    end
  end

  describe "POST #create" do
    context "with valid params" do
      it "creates a new MovieTag" do
        expect {
          post :create, params: {movie_tag: valid_attributes}, session: valid_session
        }.to change(MovieTag, :count).by(1)
      end

      it "assigns a newly created movie_tag as @movie_tag" do
        post :create, params: {movie_tag: valid_attributes}, session: valid_session
        expect(assigns(:movie_tag)).to be_a(MovieTag)
        expect(assigns(:movie_tag)).to be_persisted
      end

      it "redirects to the created movie_tag" do
        post :create, params: {movie_tag: valid_attributes}, session: valid_session
        expect(response).to redirect_to(MovieTag.last)
      end
    end

    context "with invalid params" do
      it "assigns a newly created but unsaved movie_tag as @movie_tag" do
        post :create, params: {movie_tag: invalid_attributes}, session: valid_session
        expect(assigns(:movie_tag)).to be_a_new(MovieTag)
      end

      it "re-renders the 'new' template" do
        post :create, params: {movie_tag: invalid_attributes}, session: valid_session
        expect(response).to render_template("new")
      end
    end
  end

  describe "PUT #update" do
    context "with valid params" do
      let(:new_attributes) {
        skip("Add a hash of attributes valid for your model")
      }

      it "updates the requested movie_tag" do
        movie_tag = MovieTag.create! valid_attributes
        put :update, params: {id: movie_tag.to_param, movie_tag: new_attributes}, session: valid_session
        movie_tag.reload
        skip("Add assertions for updated state")
      end

      it "assigns the requested movie_tag as @movie_tag" do
        movie_tag = MovieTag.create! valid_attributes
        put :update, params: {id: movie_tag.to_param, movie_tag: valid_attributes}, session: valid_session
        expect(assigns(:movie_tag)).to eq(movie_tag)
      end

      it "redirects to the movie_tag" do
        movie_tag = MovieTag.create! valid_attributes
        put :update, params: {id: movie_tag.to_param, movie_tag: valid_attributes}, session: valid_session
        expect(response).to redirect_to(movie_tag)
      end
    end

    context "with invalid params" do
      it "assigns the movie_tag as @movie_tag" do
        movie_tag = MovieTag.create! valid_attributes
        put :update, params: {id: movie_tag.to_param, movie_tag: invalid_attributes}, session: valid_session
        expect(assigns(:movie_tag)).to eq(movie_tag)
      end

      it "re-renders the 'edit' template" do
        movie_tag = MovieTag.create! valid_attributes
        put :update, params: {id: movie_tag.to_param, movie_tag: invalid_attributes}, session: valid_session
        expect(response).to render_template("edit")
      end
    end
  end

  describe "DELETE #destroy" do
    it "destroys the requested movie_tag" do
      movie_tag = MovieTag.create! valid_attributes
      expect {
        delete :destroy, params: {id: movie_tag.to_param}, session: valid_session
      }.to change(MovieTag, :count).by(-1)
    end

    it "redirects to the movie_tags list" do
      movie_tag = MovieTag.create! valid_attributes
      delete :destroy, params: {id: movie_tag.to_param}, session: valid_session
      expect(response).to redirect_to(movie_tags_url)
    end
  end

end
